/* Call mathematica via a file. Result is written on a file. */
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
int Id=0;
char Fname_out[1024];
int usage(void) {
  fprintf(stderr,"Usage: call_math [--host username@host] [--id Id] input_file(s)\n calls Mathematica\n");
  fprintf(stderr," Output is written on tmp-call-math-out-Id.txt\n");
  fprintf(stderr," Return value of the last line of input_file is gotten as the output.\n");
  fprintf(stderr," Newline at the end of the input_file is removed.\n");
  fprintf(stderr," Input size limit is 1024*20-1.\n");
  fprintf(stderr," You need to use ssh-agent or empty passwd .ssh/id_rsa.\n Mathematica must be installed at the host.\n");
  fprintf(stderr," Lock file is generated at ./tmp-call-math.lock\n");
  fprintf(stderr,"Example: ./call_math call-test.txt --host userid@orange\n");
  fprintf(stderr,"Example: ./call_math call-test.txt --host localhost\n");
  return(0);
}
int main(int argc, char *argv[]) {
  char comm[1024];
  char host[1024];
  char input[1024*10];
  FILE *fp;
  FILE *fp2;
  FILE *fp_lock;
  char in[1024*20];
  int i,r,c;
  int use_local_host=1;
  strcpy(host,"localhost"); input[0]=0;
  if (argc < 2) {usage(); return(-1);}
  for (i=1; i<argc; i++) {
    if (strcmp(argv[i],"--host")==0) {
      i++; strcpy(host,argv[i]);
      if (strcmp(host,"localhost")==0) use_local_host=1;
      else use_local_host=0;
    }else if (argv[i][0] != '-') {
      strcpy(&(input[strlen(input)]),argv[i]);
    }else if (strcmp(argv[i],"--id")==0) {
      i++; sscanf(argv[i],"%d",&Id);
    }else {
      fprintf(stderr,"Unknown argument\n");
      usage(); return(-1);
    }
  }
  sprintf(Fname_out,"tmp-call-math-out-%d.txt",Id);
  fprintf(stderr,"%s is used to execute Mathematica.\n",host);
  fp2=fopen(input,"r"); i=0;
  if (fp2 == NULL) { fprintf(stderr,"Error: file %s is not found.\n",input); return(-1);}

  fp_lock = fopen("tmp-call-math.lock","r");
  while (fp_lock != NULL) {
    fclose(fp_lock);
    fprintf(stderr,"call_math is locked for pid=%d...\n",getpid()); sleep(3+random()%5);
    fp_lock = fopen("tmp-call-math.lock","r");
  }
  fp_lock = fopen("tmp-call-math.lock","w");
  fclose(fp_lock);

  while ((c=fgetc(fp2)) != EOF) {
    in[i++] = c; in[i]=0;
  }
  fclose(fp2); i--;
  for ( ;i>=0; i--) {
    if (in[i] <= ' ') in[i]=0;
    else break;
  }
  fp = fopen("tmp-call-math.txt","w");
  if (fp == NULL) {fprintf(stderr,"Open error\n"); return(-1);}
  for (i=0; in[i] != 0; i++) {
    fputc(in[i],fp);
  }
  fprintf(fp,">>\"%s\"\nQuit\n",Fname_out);
  fclose(fp);
  if (use_local_host) {
#ifdef __APPLE__
    sprintf(comm,"/Applications/Mathematica.app/Contents/MacOS/MathKernel -noprompt <tmp-call-math.txt");
#else
    sprintf(comm,"math -noprompt <tmp-call-math.txt");
#endif
    //    fprintf(stderr,"%s\n",comm);
  }else {
    sprintf(comm,"cat tmp-call-math.txt | ssh %s math -noprompt ",host);
  }
  printf("comm=%s\n",comm);  
  r=system(comm);
  if (r != 0) {
    fprintf(stderr,"Error: Mathematica is not found on %s.\n",host);
    sprintf(comm,"rm -f %s",Fname_out);
    system(comm);
    return(r);
  }
  if (!use_local_host) {
    sprintf(comm,"scp %s:%s .",host,Fname_out);
    system(comm);
  }

  system("rm -f tmp-call-math.lock");
  return(r);
}
